Bug 855567 - octave should be linked with threaded version of atlas (at least on x86-64)
octave should be linked with threaded version of atlas (at least on x86-64)
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: octave (Show other bugs)
18
x86_64 Linux
unspecified Severity low
: ---
: ---
Assigned To: Jaromír Cápík
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-08 21:25 EDT by Dmitri A. Sergatskov
Modified: 2016-01-31 20:57 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 17:47:39 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dmitri A. Sergatskov 2012-09-08 21:25:32 EDT
Description of problem:

Technically, this is not a bug, but an enhancement request.

Now days most of x86-64 hardware is multi-core/multi-cpu.
On the multi-cpu platform pthreaded atlas libraries do 
offer significant performance enhancements.
The same threaded libraries would work on a single-cpu
hardware (with some performance penalty).

So I would like to ask to consider using threaded version 
of atlas libraries in octave and related packages
(e.g. suitesparse). I would imagine that other 
numerical packages (like scilab, R, numpy) would benefit from 
similar change as well, but I do not use them that much
to speak for them.

Dmitri.
Comment 1 Fedora Admin XMLRPC Client 2013-01-29 10:27:38 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 2 Fedora End Of Life 2013-07-03 18:53:21 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2013-07-31 21:05:00 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 4 Susi Lehtola 2013-08-02 08:29:35 EDT
I'm not fond of the suggestion. Or at least if a threaded version is wanted, then we should ship one version that is 100% serial and another that uses parallel libraries.

Also, OpenBLAS is now in Fedora, and in my experience it's quite much faster than ATLAS. It also has proper threaded libraries, whereas I haven't found ATLAS' parallellization to have any use...
Comment 5 Orion Poplawski 2013-08-07 22:31:37 EDT
I agree that at least the user should have the ability to determine the number of threads used at run time.  Whether this is via multiple version or available via setting environment variables, I not too concerned with.

Looking at openblas I see three different versions - main, openmp, and pthreads.  What are the differences?  Is there a preference?
Comment 6 Susi Lehtola 2013-08-08 04:39:19 EDT
openblas is serial, openblas-openmp is parallellized via OpenMP and openblas-threads is parallellized via pthreads. Since Octave isn't parallel (yet), there's no preference; any of these can be used. If Octave becomes OpenMP parallel, then one shoud use either the serial or the OpenMP version in order not to mess up the parallellization.
Comment 7 Orion Poplawski 2013-08-08 13:15:21 EDT
I built a version of octave against the serial openblas, and was encouraged by what seemed to be a 2x speedup in the benchmark_dtmm() times.  I then linked against the openblas-openmp library (as it looks like octave has openmp support that we may want to turn on) but the test suite hangs here:

  scripts/special-matrix/hadamard.m ......................

so there is work to be done there.
Comment 8 Orion Poplawski 2013-08-08 13:38:24 EDT
In further testing, the openmp version give a nearly 4x improvement in the benchmark_dtmm() times on my 4 core cpu with 4 threads, and nearly identical speeds with OMP_NUM_THREADS=1 as the serial version.  So I think linking to the openmp version of openblas by default would be a reasonable choice if we can solve the hang.
Comment 9 Susi Lehtola 2013-08-10 13:02:49 EDT
(In reply to Orion Poplawski from comment #7)
> I then linked against the openblas-openmp library (as it looks like octave has
> openmp support that we may want to turn on) but the test suite hangs here:
> 
>   scripts/special-matrix/hadamard.m ......................
> 
> so there is work to be done there.

If you remember from the Octave developers' mailing list, Octave doesn't have OpenMP support; for some reason the configure option was just added at some point in time even though there are no OpenMP directives in the code.

But yes, it might be coming in the near future.
Comment 10 Susi Lehtola 2013-08-10 13:06:25 EDT
If you plan to do the switch, remember OpenBLAS is only available on %ix86 and x86_64.
Comment 11 Fedora End Of Life 2013-12-21 10:05:42 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 12 Fedora End Of Life 2014-02-05 17:47:39 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.